'use strict'

const homographs = [
  ' \u{00A0}\u{2000}\u{2001}\u{2002}\u{2003}\u{2004}\u{2005}\u{2006}\u{2007}\u{2008}\u{2009}\u{200A}\u{202F}\u{205F}',
  '!\u{FF01}\u{01C3}\u{2D51}\u{FE15}\u{FE57}',
  '"\u{FF02}',
  '#\u{FF03}\u{FE5F}',
  '$\u{FF04}\u{FE69}',
  '%\u{FF05}\u{066A}\u{2052}\u{FE6A}',
  '&\u{FF06}\u{FE60}',
  "'\u{FF07}\u{02B9}\u{0374}",
  '(\u{FF08}\u{FE59}',
  ')\u{FF09}\u{FE5A}',
  '*\u{FF0A}\u{22C6}\u{FE61}',
  '+\u{FF0B}\u{16ED}\u{FE62}',
  ',\u{FF0C}\u{02CF}\u{16E7}\u{201A}',
  '-\u{FF0D}\u{02D7}\u{2212}\u{23BC}\u{2574}\u{FE63}',
  '.\u{FF0E}\u{2024}',
  '/\u{FF0F}\u{1735}\u{2044}\u{2215}\u{29F8}',
  // '0',
  // '1',
  '2\u{14BF}',
  '3\u{01B7}\u{2128}',
  '4\u{13CE}',
  // '5',
  '6\u{13EE}',
  // '7',
  // '8',
  '9\u{13ED}',
  ':\u{FF1A}\u{02D0}\u{02F8}\u{0589}\u{1361}\u{16EC}\u{205A}\u{2236}\u{2806}\u{FE13}\u{FE55}',
  ';\u{FF1B}\u{037E}\u{FE14}\u{FE54}',
  '<\u{FF1C}\u{02C2}\u{2039}\u{227A}\u{276E}\u{2D66}\u{FE64}',
  '=\u{FF1D}\u{2550}\u{268C}\u{FE66}',
  '>\u{FF1E}\u{02C3}\u{203A}\u{227B}\u{276F}\u{FE65}',
  '?\u{FF1F}\u{FE16}\u{FE56}',
  '@\u{FF20}\u{FE6B}',
  'A\u{0391}\u{0410}\u{13AA}',
  'B\u{0392}\u{0412}\u{13F4}\u{15F7}\u{2C82}',
  'C\u{03F9}\u{0421}\u{13DF}\u{216D}\u{2CA4}',
  'D\u{13A0}\u{15EA}\u{216E}',
  'E\u{0395}\u{0415}\u{13AC}',
  'F\u{15B4}',
  'G\u{050C}\u{13C0}',
  'H\u{0397}\u{041D}\u{12D8}\u{13BB}\u{157C}\u{2C8E}',
  'I\u{0399}\u{0406}\u{2160}',
  'J\u{0408}\u{13AB}\u{148D}',
  'K\u{039A}\u{13E6}\u{16D5}\u{212A}\u{2C94}',
  'L\u{13DE}\u{14AA}\u{216C}',
  'M\u{039C}\u{03FA}\u{041C}\u{13B7}\u{216F}',
  'N\u{039D}\u{2C9A}',
  'O\u{039F}\u{041E}\u{2C9E}',
  'P\u{03A1}\u{0420}\u{13E2}\u{2CA2}',
  'Q\u{051A}\u{2D55}',
  'R\u{13A1}\u{13D2}\u{1587}',
  'S\u{0405}\u{13DA}',
  'T\u{03A4}\u{0422}\u{13A2}',
  // 'U',
  'V\u{13D9}\u{2164}',
  'W\u{13B3}\u{13D4}',
  'X\u{03A7}\u{0425}\u{2169}\u{2CAC}',
  'Y\u{03A5}\u{2CA8}',
  'Z\u{0396}\u{13C3}',
  '[\u{FF3B}',
  '\\\u{FF3C}\u{2216}\u{29F5}\u{29F9}\u{FE68}',
  ']\u{FF3D}',
  '^\u{FF3E}\u{02C4}\u{02C6}\u{1DBA}\u{2303}',
  '_\u{FF3F}\u{02CD}\u{268A}',
  '`\u{FF40}\u{02CB}\u{1FEF}\u{2035}',
  'a\u{0251}\u{0430}',
  // 'b',
  'c\u{03F2}\u{0441}\u{217D}',
  'd\u{0501}\u{217E}',
  'e\u{0435}\u{1971}',
  // 'f',
  'g\u{0261}',
  'h\u{04BB}',
  'i\u{0456}\u{2170}',
  'j\u{03F3}\u{0458}',
  // 'k',
  'l\u{217C}',
  'm\u{217F}',
  'n\u{1952}',
  'o\u{03BF}\u{043E}\u{0D20}\u{2C9F}',
  'p\u{0440}\u{2CA3}',
  // 'q',
  // 'r',
  's\u{0455}',
  // 't',
  'u\u{1959}\u{222A}',
  'v\u{1D20}\u{2174}\u{2228}\u{22C1}',
  'w\u{1D21}',
  'x\u{0445}\u{2179}\u{2CAD}',
  'y\u{0443}\u{1EFF}',
  'z\u{1D22}',
  '{\u{FF5B}\u{FE5B}',
  '|\u{FF5C}\u{01C0}\u{16C1}\u{239C}\u{239F}\u{23A2}\u{23A5}\u{23AA}\u{23AE}\u{FFE8}',
  '}\u{FF5D}\u{FE5C}',
  '~\u{FF5E}\u{02DC}\u{2053}\u{223C}'
]

const dict = new Map()
const reverse = new Map()

for (let entry of homographs) {
  entry = Array.from(entry)
  const ascii = entry.splice(0, 1)[0]
  for (let char of entry) {
    reverse.set(char, ascii)
  }
  dict.set(ascii, entry)
}

module.exports.dict = dict
module.exports.reverse = reverse
